C signer action
curl --request POST \
--url https://api.hyperliquid.xyz/exchange \
--header 'Content-Type: application/json' \
--data '
{
"action": {
"type": "CSignerAction",
"unjailSelf": null
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": null
}
'import requests
url = "https://api.hyperliquid.xyz/exchange"
payload = {
"action": {
"type": "CSignerAction",
"unjailSelf": None
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": None
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
action: {type: 'CSignerAction', unjailSelf: null},
nonce: 1705234567890,
signature: {
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
},
vaultAddress: null
})
};
fetch('https://api.hyperliquid.xyz/exchange', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"status": "<string>",
"response": {}
}Hyperliquid node API
CSignerAction | Hyperliquid exchange
Performs a consensus signer action for validator operations on the Hyperliquid network. Chainstack Hyperliquid exchange reference.
POST
/
exchange
C signer action
You can only use this endpoint on the official Hyperliquid public API. It is not available through Chainstack, as the open-source node implementation does not support it yet. See Hyperliquid methods for the full availability breakdown.
This endpoint requires signature authentication. See our comprehensive Authentication via Signatures guide for implementation details.
Get your own node endpoint todayStart for free and get your app to production levels immediately. No credit card required.You can sign up with your GitHub, X, Google, or Microsoft account.
Parameters
Required parameters
action(object, required) — The action object containing:type(string) — Must be"CSignerAction"payload(object) — Signer action payload
nonce(number, required) — Current timestamp in milliseconds (must be recent)signature(object, required) — EIP-712 signature of the action
Optional parameters
vaultAddress(string, optional) — Address when trading on behalf of a vault or subaccount
Returns
Returns an object with the action status:status—"ok"if request processedresponse— Contains action result data
Example request
curl -X POST https://api.hyperliquid.xyz/exchange \
-H "Content-Type: application/json" \
-d '{
"action": {"type": "CSignerAction"},
"nonce": 1234567890123,
"signature": {...}
}'
from hyperliquid.exchange import Exchange
from hyperliquid.utils import constants
from eth_account import Account
# Validator signer wallet — replace with your own key handling
wallet = Account.from_key("0x...")
# Public-only method: use the Hyperliquid mainnet API
exchange = Exchange(wallet, constants.MAINNET_API_URL)
# Jail self as a validator signer
result = exchange.c_signer_jail_self()
# Unjail self as a validator signer
# result = exchange.c_signer_unjail_self()
print(result)
import { ExchangeClient, HttpTransport } from "@nktkas/hyperliquid";
import { privateKeyToAccount } from "viem/accounts";
// Validator signer wallet — replace with your own key handling
const wallet = privateKeyToAccount("0x...");
// Public-only method: default transport targets the Hyperliquid mainnet API
const transport = new HttpTransport();
const exchange = new ExchangeClient({ transport, wallet });
// Jail self as a validator signer
const result = await exchange.cSignerAction({ jailSelf: null });
// Unjail self as a validator signer
// const result = await exchange.cSignerAction({ unjailSelf: null });
console.log(result);
Use case
- C signer action — Performs a consensus signer action for validator operations on the Hyperliquid network.
Always ensure your system clock is synchronized. Nonce must be within a reasonable time window of the current server time or the request will be rejected.
Body
application/json
Last modified on June 24, 2026
Was this page helpful?